/* ------------------------------------------------------------------------------------------------
 * ClipBlast! 3.0
 * 
 * depencies:
 * mootools.v1.11.js
 * ------------------------------------------------------------------------------------------------
 */

if (typeof console == "undefined"){
	var console = {
		log : function(msg){
			//alert(msg);
		}
	}
}


/* ------------------------------------------------------------------------------------------------
 * Mootools extensions
 * ------------------------------------------------------------------------------------------------
 */

// Add a stop to the Group
Group = Group.extend({
	/*
	Property: addElement
		adds an element to the stack of elements to be monitored.

	Arguments:
		element - element; the element to monitor
	*/
	addElement: function(element){
		this.instances.push(element);
	},

	/*
	Property: stop
		stops monitoring events.

	Arguments:
		type - string; the event name for which to stop watching events (e.g. 'onComplete')
	*/
	stop: function(type){
		this.events[type] = [];
	}
});

// bug fix to Asset.image
Asset.image = function(source, properties){
	properties = $merge({
		'onload': Class.empty,
		'onabort': Class.empty,
		'onerror': Class.empty
	}, properties);
	var image = new Image();
	image.src = source;
	var element = new Element('img', {'src': source});
	['load', 'abort', 'error'].each(function(type){
		var event = properties['on' + type];
		delete properties['on' + type];
		element.addEvent(type, function(){
			this.removeEvent(type, arguments.callee);
			event.call(this);
		});
	});
	//if (image.width && image.height) element.fireEvent('load', element, 1);
	return element.setProperties(properties);
}

// String extenstions copied from prototype.js
$extend(String, {
  interpret: function(value) {
    return value == null ? '' : String(value);
  },
  specialChar: {
    '\b': '\\b',
    '\t': '\\t',
    '\n': '\\n',
    '\f': '\\f',
    '\r': '\\r',
    '\\': '\\\\'
  }
});
$extend(String.prototype, {
	gsub : function(pattern, replacement) {
		var result = '', source = this, match;
		replacement = arguments.callee.prepareReplacement(replacement);

		while (source.length > 0) {
			if (match = source.match(pattern)) {
				result += source.slice(0, match.index);
				result += String.interpret(replacement(match));
				source  = source.slice(match.index + match[0].length);
			} else {
				result += source, source = '';
			}
		}
		return result;
	},
	truncate: function(length, truncation) {
		length = length || 30;
		truncation = truncation === undefined ? '...' : truncation;
		return this.length > length ?
			this.slice(0, length - truncation.length) + truncation : this;
	},
	parseQuery: function() {
		var pairs = this.match(/^\??(.*)$/)[1].split('&');
		var params = {};
		pairs.each(function(pair) {
		  pair = pair.split('=');
		  params[pair[0]] = pair[1];
		});
		return params;
	}
});
String.prototype.gsub.prepareReplacement = function(replacement) {
	if (typeof replacement == 'function') return replacement;
	var template = new Template(replacement);
	return function(match) { return template.evaluate(match) };
}

Element.extend({

	toObject: function(){
		var obj = {};
		this.getFormElements().each(function(el){
			var name = el.name;
			var value = el.getValue();
			if (value === false || !name || el.disabled) return;
			obj[name] = value;
		});
		return obj;
	},
	
	show: function(){
		this.style.display = "block";
		return this;
	},
	
	hide: function(){
		this.style.display = "none";
		return this;
	}

});

/*
 * Template Class
 */
var Template = new Class({
	initialize: function(template, pattern) {
		this.template = template.toString();
		this.pattern  = pattern || Template.Pattern;
	},

	evaluate: function(object) {
		return this.template.gsub(this.pattern, function(match) {
			var before = match[1];
			if (before == '\\') return match[2];
			return before + String.interpret(object[match[3]]);
		});
	}
});
Template.Pattern = /(^|.|\r|\n)(#\{(.*?)\})/;


/* ------------------------------------------------------------------------------------------------
 * Global CB object and variables
 * ------------------------------------------------------------------------------------------------
 */
var CB = {};

CB.$ = {
	searchOptions : {
		userVideo : Cookie.get("userVideo") || "false",
		safeSearch : Cookie.get("safeSearch") || "true",
		sortBy : Cookie.get("sortBy") || "standard",
		searchMethod : "all",
		output : "json"
	},
	api : {
		search : "http://www.clipblast.com/api/index/all.php",
		//realtime : "http://www.clipblast.com/api/index/realtimeJSON.php",
		realtime : "http://www.clipblast.com/api/index/realtime-static.php",
		login : "http://www.clipblast.com/api/user/login.php",
		updateProfile : "http://www.clipblast.com/api/user/updateProfile.php",
		subscribe : "http://www.clipblast.com/api/user/signup.php",
		logClipView : "http://www.clipblast.com/api/logging/clipView.php",
		savedSearches : "http://www.clipblast.com/api/mycb/savedSearches.php",
		myFavorites : "http://www.clipblast.com/api/favorites.php",
		recentViews : "http://www.clipblast.com/api/recent.php",
		totalClips : "http://www.clipblast.com/api/index/totalClips.php",
		hourlyClips : "http://www.clipblast.com/api/index/hourlyClips.php",
		saveClip : "http://www.clipblast.com/api/mycb/updateSavedClips.php"
	},
	portlets : {
		recommended : "http://www.clipblast.com/v3/includes/portlets/portletRecommendedVideos.html",
		topRated : "http://www.clipblast.com/v3/includes/portlets/portletTopRated.html",
		featuredProviders : "http://www.clipblast.com/v3/includes/portlets/portletFeaturedProvidersWidget.html",
		myCategories : "http://www.clipblast.com/v3/includes/portlets/portletMyCategories.html"
	},
	templates : {
		clipDt : '<a href="#{url}" rel="#{clipId}">#{title}</a>',
		clipDd : '<p class="illustration"><img src="#{image}" alt="" /> <em class="clipDate">#{published}</em> #{playButton}</p><p>#{description}</p><p class="footer"><a href="#{url}" rel="#{clipId}">Watch at</a><a href="/provider/#{ownerId}/#{source}" class="provider">#{source}</a><a href="/clip/#{clipId}/save">Add to Library</a></p>',
		clipPlayButton : '<a href="#{asset}" class="buttonPlay-medium" rel="play #{clipId} #{player} #{ownerId}" title="#{source}: #{title}">Play this video</a>',
		clipRealTime : '<li><span><span><img src="#{image}" alt="" /></span></span><a href="#{url}" rel="#{clipId}"><span>#{title}</span></a></li>',
		notLoggedIn : 'You will need to be logged in to use this feature. Please enter your login information at the <a href="javascript:showPrefs()">backside</a> of this widget or register first at <a href="http://www.clipblast.com" target="browser" onclick="widget.openURL(\'http://www.clipblast.com\');">www.clipblast.com</a>.'
	},
	flvPlayers : [{
			provider : "youtube",
			regExp : /youtube\.com\//,
			regExpId : /v\=(\S+)$/,
			url : "http://www.youtube.com/v/#{videoId}&autoplay=1",
			width : 425,
			height: 350,
			flashVersion : 8
		},{
			provider : "myspace",
			regExp : /myspace\.com\//,
			regExpId : /videoid\=(\w+)$/,
			url : "http://lads.myspace.com/videos/vplayer.swf",
			params : [
				["flashVars","m=#{videoId}&type=video&a=1"]
			],
			width : 430,
			height: 346,
			flashVersion : 8
		},/*{
			provider : "amazon",
			regExp : /amazon\.com\//,
			regExpId : /product\/(\w*)\//,
			url : "http://images.amazon.com/images/G/01/digital/video/associates/AssociatesPlayer.swf",
			params : [
				["align", "middle"],
				["allowScriptAccess", "always"],
				["flashVars","associatesTag=clipblast&autoPlay=true&view=PACK&tab1=ad%2Chttp%3A%2F%2Fwww%2Eamazon%2Ecom%2Fgp%2Fvideo%2Fxml%2Ffeed%2Ffeed%2Exml%3F%26Detailed%3DT%26HasImage%3DT%26ASINList%3D#{videoId}&startMuted=false&usePopUp=false"]
			],
			width : 500,
			height: 400,
			flashVersion : 8
		},*/{
			provider : "ifilm",
			regExp : /ifilm\.com\//,
			regExpId : /video\/(\d*)\?/,
			url : "http://www.ifilm.com/efp",
			params : [
				["flashVars","flvbaseclip=#{videoId}&ip=true"]
			],
			width : 448,
			height: 365,
			flashVersion : 8
		},{
			provider : "comedycentral",
			regExp : /comedycentral\.com\//,
			regExpId : /playVideo=(\d+)/,
			url : "http://www.comedycentral.com/sitewide/video_player/view/default/swf.jhtml",
			params : [
				["flashVars","videoId=#{videoId}"]
			],
			width : 332,
			height: 316,
			flashVersion : 8
		},{
			provider : "videodetective",
			regExp : /videodetective\.com\//,
			regExpId : /PublishedID=(\d+)/,
			url : "http://www.videodetective.com/codes/flvcodeplayer.swf",
			params : [
				["flashVars","&file=#{videoId}&height=325width=400&autostart=true&shuffle=false"]
			],
			width : 400,
			height: 325,
			flashVersion : 8
		},{
			provider : "5min",
			regExp : /5min\.com\//,
			regExpId : /\-(\d+)\?src/,
			url : "http://www.5min.com/Players/5minEmbedPlayer.swf",
			params : [
				["flashVars","videoID=#{videoId}"]
			],
			width : 400,
			height: 325,
			flashVersion : 8
		},{
			provider : "veoh",
			regExp : /veoh\.com\//,
			regExpId : /v=(\w+)$/,
			url : "http://www.veoh.com/videodetails2.swf?permalinkId=#{videoId}&id=anonymous&player=videodetailsembedded&videoAutoPlay=1",
			width : 540,
			height: 438,
			flashVersion : 8
		},{
			provider : "mdc",
			regExp : /mydamnchannel\.com\//,
			regExpId : /episode=(\d+)$/,
			url : "http://www.mydamnchannel.com/xml/mdc_embed.swf?episode=#{videoId}",
			width : 400,
			height: 336,
			flashVersion : 8
		},{
			provider : "theonion",
			regExp : /theonion\.com\//,
			regExpId : /\~3\/\d+\/(\d+)$/,
			url : "http://www.theonion.com/content/themes/common/assets/videoplayer/flvplayer.swf",
			params : [
				["flashVars","file=http://www.theonion.com/content/xml/#{videoId}/video&autostart=true"]
			],
			width : 400,
			height: 355,
			flashVersion : 8
		},{
			provider : "gotuit",
			regExp : /gotuitmusic\.com\//,
			regExpId : /\&(p=\d+\&s=\d+)\&/,
			url : "http://www.gotuitmusic.com/player/eplayer.swf",
			params : [
				["flashVars","c=Videos&#{videoId}&o=gotuitmusicEmbed"]
			],
			width : 410,
			height: 347,
			flashVersion : 8
		}
	],
	domain : /file:\/\/\//,
	includesDir : "http://www.clipblast.com/v3/includes/widget/",
	rootDir : "/v3/",
	months : ['January','February','March','April','May','June','July','August','September','October','November','December']
}


/* ------------------------------------------------------------------------------------------------
 * Main Controller
 * The main controller initiates all components and ties all links and forms to JavaScript functions
 * ------------------------------------------------------------------------------------------------
 */

CB.Controller = {
	init : function(){
		// initialize components
		CB.User.init();
		CB.Search.init();
		CB.Homepage.init();
		CB.Player.init();
		CB.RealTimeIndex.init();
		CB.Portlets.categories.init();
		CB.Portlets.providers.init();
		CB.Clip.init();
		CB.Transitions.init();
		
		// todo: init these components after page loads or login
		//CB.Portlets.myClips.init();
		//CB.Portlets.recentViews.init();
		//CB.Portlets.savedSearches.init();
		
		this.hijackEvents();
		
		// load widget title
		new Ajax(CB.$.includesDir + "widgetTitle.html",{
			update : $E("#navigator h3"),
			method: "get"
		}).request();
	},
	
	hijackEvents : function(scope){
		var scope = scope || $(document.body);
		scope.getElements("a").each(function(lnk){
			lnk.addEvent("click",this.handleEvent.bindAsEventListener(this,[lnk,"link"]))
		},this);
		scope.getElements("form").each(function(form){
			form.addEvent("submit",this.handleEvent.bindAsEventListener(this,[form,"form"]))
		},this);
	},
	
	handleEvent : function(evt,element,type){
		var event = new Event(evt);
		if (type == "link"){
			var url = element.href;
			var rel = element.getProperty("rel");
			if (CB.$.domain.test(url)){
				event.stop();
				this.execute(url.replace(CB.$.domain,""));
			} else {
				// check if it can be played on Clipblast
				if (rel.contains("play")){
					event.stop();
					rel = rel.split(" ");
					var clipId = rel[1];
					var ownerId = rel[3] || null;
					var title = element.title || "";
					CB.Player.play(url,rel[2],clipId,title,ownerId);
				} else {
					event.stop();
					widget.openURL(url);
					var clipId = rel;
				}
				//log clip view
				if (clipId && clipId.test(/^[0-9]+$/)){
					this.logClipView(clipId);
				}
			}
		}
		
		if (type == "form"){
			event.stop();
			var action = element.action.replace(CB.$.domain,"").replace(/^\//,"");
			var data = element.toQueryString();
			this.execute(action,data);
		}
	},
	
	execute : function(url,data){
		// do nothing for links with href #
		if (url.match("#")){
			return;
		}
		
		var action = url.split("/");
		console.log(action);
		switch(action[0]){
			case "provider":
			case "category":
			case "moreLikeThis" :
				if (action[0]=="search") action[0] = "phrase";
				if (action[0]=="provider") action[0] = "owner";
				var search = (action[0]=="phrase") ? action[1] : (action[2]||"");
				var searchOptions = {};
				searchOptions[action[0]] =  action[1];
				console.log(searchOptions);
				CB.Search.start(searchOptions,search);
				break;
			
			case "search" :
				var searchOptions = action[1].parseQuery();
				CB.Search.start(searchOptions);
				break;
				
			case "static" :
				var url = CB.includes_dir + "/" + action[1] + ".html";
				this.loadStaticPage(action[1]);
				break;
				
			case "clip":
				CB.Clip[action[2]](action[1]);
				break;
			
			case "filter":
				var filterOptions = {};
				var type = (action[1]=="provider") ? "owner" : action[1];
				filterOptions[type] = action[2] || "";
				var currentFilterType = action[2] ? action[1] : null;
				CB.Search.filter(filterOptions,currentFilterType);
				break;
				
			case "":
				break;
		}
		
		
		// Todo: do something with trackEvent
		
		
	},
	
	logClipView : function(clipId){
		var data = {
			user_id : CB.User.getId(),
			//phrase : $("phrase").value,
			clipId : clipId
		}
		new Ajax(CB.$.api.logClipView,{
			method:'post',
			data: data
		}).request();
	}
}
$extend(CB.Controller,new Events);

/* ------------------------------------------------------------------------------------------------
 * Clip
 * ------------------------------------------------------------------------------------------------
 */

CB.Clip = {
	init : function(){
		$('buttonClose').addEvent('click',this.closeNotify.bind(this));
		$('buttonShareSend').addEvent('click',this.closeShare.bind(this));
		$('buttonShareCancel').addEvent('click',this.closeShare.bind(this));
	},

	closeNotify : function(){
		CB.Transitions.savedHide();
	},

	save : function(clipId){
		this.send(clipId,"add");
	},
	
	remove : function(){
		this.send(clipId,"remove");
	},
	
	send : function(clipId,action){
		new Ajax(CB.$.api.saveClip, {
			method: 'post',
			data : {
				action: action,
				clipId : clipId,
				user_id : CB.User.getId()
			},
			onComplete : this.confirm.bind(this,action)
		}).request();
	},
	
	confirm : function(action){
		if (action == "add"){
			CB.Transitions.savedShow();
		} else {
			//$flash("Clip has been removed");
		}
	},
	
	share : function(data){
		CB.Transitions.shareShow();
	},
	
	sendShare : function(){
		CB.User.verifyLogin();
		new Ajax(CB.$.api.shareClip, {
			method: 'post',
			data : data,
			onComplete : this.confirm.bind(this,"share")
		});
	},
	
	closeShare : function(){
		CB.Transitions.shareHide();
	},
	
	details : function(){
		//todo
	}
}

/* ------------------------------------------------------------------------------------------------
 * Clipblast User
 * ------------------------------------------------------------------------------------------------
 */

CB.User = {
	user : {
		userId :  null,
		userName :  null,
		password : null,
		email :  null
	},
	
	getId : function(){
		return this.user.userId;
	},
	
	init : function(){
		this.userName = $('username').value;
		this.password = $('password').value;
		this.transport = new Ajax(CB.$.api.login, {
			method: 'post',
			onComplete : this.handleLogIn.bind(this),
			onFailure : this.onFailure.bind(this)
		});
		this.verifyLogin();
	},

	verifyLogin : function() {
		if (this.userId) {
			return;
		}
		if (this.userName && this.password) {
			var query = "user_name=" + this.userName + "&password=" + this.password;
			this.logIn(query);
		}
	},
	
	logIn : function(data){
		if (this.user.userId){
			this.logOut();
		}
		this.transport.options.data = data;
		this.transport.request();
	},
	
	handleLogIn : function(responseText,xml){
		var user = xml.getElementsByTagName('user');  // or whatever each result is called
		if(user[0] == null) {
			this.onFailure();
			return false;
		}
		this.user = {
			userName : xml.getElementsByTagName('name')[0].childNodes[0].nodeValue || null,
			userId :  xml.getElementsByTagName('id')[0].childNodes[0].nodeValue || null,
			email : xml.getElementsByTagName('email')[0].childNodes[0].nodeValue || null
		}
		//CB.Portlets.myClips.init();
		//CB.Portlets.recentViews.init();
		//CB.Portlets.savedSearches.init();
		CB.Transitions.reopenCurrentPage();
	},
	
	logOut : function(){
		this.user.userId = null;
	},
	
	onFailure : function(){
		// todo
	}
}

/* ------------------------------------------------------------------------------------------------
 * Portlets
 * ------------------------------------------------------------------------------------------------
 */
CB.Portlets = {
	updateRelativeImages : function(scope){
		// TODO create an URL for the images
		scope.getElements("img").each(function(img){
			var src = img.src;
			if (src.substr(0,5) == "http:"){
				return;
			}

			var name = "Clipblast.wdgt/";
			if (src.indexOf(name) >= 0) {
				img.src = "http://www.clipblast.com/v3/" + src.substring(src.indexOf(name) + name.length);
			} else if (src.indexOf("file:///") == 0) {
				img.src = "http://www.clipblast.com/" + src.substring(8);
			} else if (src.charAt(0) == '/'){
				img.src = "http://www.clipblast.com" + src;
			} else {
				img.src = "http://www.clipblast.com/v3/" + src;
			}
		},this);
	},
	
	providers : {
		init : function(){
			if (this.initialized){
				return;
			}
			this.width = 300;
			this.portlet = new Component.Portlet($('providers'),{itemsOnSlide:1});
			this.portlet.load("featuredProviders","Featured Providers");
			this.initialized = 1;
		}
	},
	
	myProviders : {
		init : function(){
			if (this.initialized){
				return;
			}
			this.element = $("myProviders");
			var userId = CB.User.getId();
			if (!userId){
				if (!this.login) this.login = new Element("p").setHTML(CB.$.templates.notLoggedIn).injectBefore(this.element.getElement("div.carousel"));
				return;
			} else if (this.login) {
				this.login.remove();
			}
			this.width = 300;
			this.portlet = new Component.Portlet(this.element,{itemsOnSlide:1});
			this.initialized = 1;
		},
		
		refresh : function(){
			this.init();
			if (this.initialized) {
				this.portlet.load("myProviders","My Providers");
			}
		}
	},
	
	categories : {
		init : function(){
			if (this.initialized){
				return;
			}
			this.width = 300;
			this.portlet = new Component.Portlet($('categories'),{width:316,itemsOnSlide:1});
			this.portlet.addEvent("onLoad", function(){
				$$("#categories ul a").each(function(lnk){
					var categoryString = lnk.href.split("category/")[1];
					var category = categoryString.split("/");
					var imageSrc = "media/" + category[1].toLowerCase().replace(/(\%20|\&|\s)/gi,"") + ".gif";
					var categoryImage = new Asset.image(imageSrc,{alt:category[1]});
					categoryImage.injectTop(lnk);
				}.bind(this));
			}.bind(this));
			this.portlet.load("categories","Clipblast! Categories");
			this.initialized = 1;
		}
	},
	
	myCategories : {
		init : function(){
			if (this.initialized){
				return;
			}
			this.element = $("myCategories");
			var userId = CB.User.getId();
			if (!userId){
				if (!this.login) this.login = new Element("p").setHTML(CB.$.templates.notLoggedIn).injectBefore(this.element.getElement("div.carousel"));
				return;
			} else if (this.login) {
				this.login.remove();
			}
			this.width = 300;
			this.portlet = new Component.Portlet(this.element,{width:316,itemsOnSlide:1});
			this.portlet.addEvent("onLoad", function(){
				$$("#myCategories ul a").each(function(lnk){
					var categoryString = lnk.href.split("category/")[1];
					var category = categoryString.split("/");
					var imageSrc = "media/" + category[1].toLowerCase().replace(/(\%20|\&|\s)/gi,"") + ".gif";
					var categoryImage = new Asset.image(imageSrc,{alt:category[1]});
					categoryImage.injectTop(lnk);
				}.bind(this));
			}.bind(this));
			this.initialized = 1;
		},
		
		refresh : function(){
			this.init();
			if (this.initialized) {
				this.portlet.load("myCategories","My Categories");
			}
		}
		
	},
	
	savedSearches : {
		init : function(){
			if (this.initialized){
				return;
			}
			this.element = $("savedSearches");
			var userId = CB.User.getId();
			if (!userId){
				if (!this.login) this.login = new Element("p").setHTML(CB.$.templates.notLoggedIn).injectBefore(this.element.getElement("ul"));
				return;
			} else if (this.login) {
				this.login.remove();
			}
			this.initialized = 1;
		},
		
		refresh : function(){
			this.init();
			if (this.initialized) {
				new Ajax(CB.$.api.savedSearches,{
					method:"get",
					data: {
						action: "list",
						userId: CB.User.getId()
					},
					onComplete: this.showSavedSearches.bind(this)
				}).request();
			}
		},
		
		showSavedSearches : function(responseText,responseXML){
			var result = Json.evaluate.attempt(responseText);
			if (result){
				var container = this.element.getElement("ul");
				container.empty();
				this.searches = result.searches;
				
				this.searches.each(function(search){
					var query = search.query.parseQuery();
					var searchTitle = [];
					if (query.phrase) searchTitle.push(query.phrase);
					if (query.categoryName) searchTitle.push(query.categoryName);
					if (query.ownerName) searchTitle.push(query.ownerName);
					if (query.platformName) searchTitle.push(query.platformName);
					search.title = searchTitle.join(", ");
					
					var li = new Element("li",{"id":"search"+search.searchId}).injectInside(container);
					li.setHTML(new Template('<a href="/search/#{query}">#{title}</a> <em class="provider">#{sourceName}</em> <em class="category">#{categoryName}</em>').evaluate(search));
					
				},this);
				CB.Controller.hijackEvents(container);
			} else {
				this.element.setHTML("Loading of your saved searches failed.");
			}
		}
	},
	
	myClips : {
		init : function(){
			if (this.initialized){
				return;
			}
			var element = $("myClips");
			var userId = CB.User.getId();
			if (!userId){
				if (!this.login) this.login = new Element("p").setHTML(CB.$.templates.notLoggedIn).injectBefore(element.getElement("dl"));
				return;
			} else if (this.login) {
				this.login.remove();
			}
			var options = {
				userId : userId,
				limit: 6,
				output: "json",
				offset: 0,
				listType : "saved",
				searchKey: "72.51.43.55"
			}
			this.searchPanel = new CB.Portlets.SearchPanel(element,options);
			this.initialized = 1;
		},
		refresh : function(){
			if (this.initialized) {
				this.searchPanel.searchComponent.start();
			} else {
				this.init();
			}
		}
	},
	
	recentViews : {
		init : function(){
			if (this.initialized){
				return;
			}
			var element = $("recentViews");
			var userId = CB.User.getId();
			if (!userId){
				if (!this.login) this.login = new Element("p").setHTML(CB.$.templates.notLoggedIn).injectBefore(element.getElement("dl"));
				return;
			} else if (this.login) {
				this.login.remove();
			}
			var options = {
				userId : userId,
				limit: 6,
				output: "json",
				offset: 0,
				listType : "recent",
				searchKey: "72.51.43.55"
			}
			this.searchPanel = new CB.Portlets.SearchPanel(element,options);
			this.initialized = 1;
		},
		
		refresh : function(){
			if (this.initialized) {
				this.searchPanel.searchComponent.start();
			} else {
				this.init();
			}
		}
	},
	
	SearchPanel : new Class({
		initialize : function(element,options){
			this.options = options;
			this.element = $(element);
			this.searchContainer = this.element.getElement("dl");
			this.searchComponent = new Component.SearchContainer(this.searchContainer,options);
	
			// pagination
			var previous = this.element.getElement(".buttonPrevious");
			var counter = this.element.getElement("em.counter");
			var next = this.element.getElement(".buttonNext");
			this.paginator = new Component.Paginator(counter, previous, next, this.searchComponent.previous.bind(this.searchComponent), this.searchComponent.next.bind(this.searchComponent));
			
			this.searchComponent.addEvent("resultLoaded",function(container,properties,options,metaData){
				CB.Controller.hijackEvents(container);
				
				var page = properties.start/this.options.limit + 1;
				var numPages = Math.ceil(properties.numFound/this.options.limit);
				this.paginator.setPage(page, numPages);
			}.bind(this));
			this.searchComponent.start();
		}
	})
}

/* ------------------------------------------------------------------------------------------------
 * Search
 * ------------------------------------------------------------------------------------------------
 */

CB.Search = {
	displayMode : CB.$.searchView,
	options : {
		limit : 6,
		userVideo : "false",
		safeSearch : "true",
		sortBy : "standard",
		offset: 0,
		searchKey: "72.51.43.55",
		output : "json"
	},
	
	init : function(){
		
		this.form =  $("searchForm");
		this.form.addEvent("submit",this.search.bindAsEventListener(this));
		this.searchInput = new Component.InputField("phrase");
		this.searchContainer = $("results");
		
		this.searchComponent = new Component.SearchContainer(this.searchContainer,this.options);

		// pagination
		var previous = $E("#results .buttonPrevious");
		var counter = $E("#results em.counter");
		var next = $E("#results .buttonNext");
		this.paginator = new Component.Paginator(counter, previous, next, this.searchComponent.previous.bind(this.searchComponent), this.searchComponent.next.bind(this.searchComponent));
		
		this.searchComponent.addEvent("resultLoaded",function(container,properties,options,metaData){
			CB.Controller.hijackEvents(container);
			
			var page = properties.start/this.options.limit + 1;
			var numPages = Math.ceil(properties.numFound/this.options.limit);
			this.paginator.setPage(page, numPages);
		}.bind(this));
			
	},
	
	filter : function(filterOptions,type){
		this.currentFilterType = type;
		this.searchComponent.filter(filterOptions,type);
	},
	
	start : function(options){
		this.searchComponent.start(options);
		CB.Transitions.search();
	},
	
	search : function(event){
		if (event){
			var event = new Event(event);
			event.stop();
		}
		var searchOptions = {phrase: $("phrase").value}
		CB.Search.start(searchOptions);
	}


}
$extend(CB.Search,new Events);

/* ------------------------------------------------------------------------------------------------
 * Player
 * ------------------------------------------------------------------------------------------------
 */

CB.Player = {
	init : function(){
		this.fromPage = 0;
		this.visible = false;
		this.clipId = -1;
		this.providerAnchor = $E('#video h3.clipTitle a');
		this.titleSpan = $E('#video h3.clipTitle span');
		this.flvPlayers = CB.$.flvPlayers;
		console.log(this.flvPlayers)
		this.providers = this.flvPlayers.map(function(item){
			return item.provider;
		});
		this.players = this.flvPlayers.associate(this.providers);
		
		// create player container
		//var player = new Element("div").setProperty("id","moviePlayer").addClass("closed").injectInside(document.body);
		var close = new Element("a").setProperties({"id":"moviePlayerClose","href":"#"}).setText("Close").injectInside("video");
		this.playerContainer = new Element("span").setProperty("id","moviePlayerContent").injectInside("video");
		close.addEvent("click",function(event){
			var event = new Event(event);
			event.stop();
			this.stop();
			//CB.Transitions.search();
		}.bindAsEventListener(this));

		var save = $$('#videoFunctions button.buttonSave');
		save.addEvent("click",function(event){
			new Event(event).stop();
			this.saveClip();
		}.bindAsEventListener(this));
		var share = $$('#videoFunctions button.buttonShare');
		share.addEvent("click",function(event){
			new Event(event).stop();
			this.shareClip();
		}.bindAsEventListener(this));
	},
	
	getPlayer : function(url,clip){
		var player = null;
		if (clip && clip.podcast && clip.podcast == true){
			var playable = true;
			player = {
				provider : "podcast"
			};
		} else {
			var playable = this.flvPlayers.some(function(flvPlayer){
				player = flvPlayer;
				return flvPlayer.regExp.test(url);
			});
		}
		
		return playable ? player : false;
	},

	stop : function() {
		// TODO stop the video
		this.hidePlayer();
		this.clipId = -1;
	},
	
	setupPlayer : function(url,provider){
		this.playerContainer.empty();
		var player = this.players[provider];
		var videoId = url.match(player.regExpId)[1];
		var so = new SWFObject(player.url.replace(/#{videoId}/,videoId), "Player", player.width.toString(), player.height.toString(), player.flashVersion.toString());
		if (player.params){
			player.params.each(function(param){
				so.addParam(param[0],param[1].replace(/#{videoId}/,videoId));
			});
		};
		//so.addParam("wmode", "opaque");
		so.write("moviePlayerContent");
		
		// Todo: play movie
	},
	
	setupPlayerQuicktime : function(url,provider){
		this.playerContainer.empty();
		var playerCode = '<object id="Player" scale="aspect"><param name="src" value="'+url+'"><param name="autoplay" value="true"></object>';
		this.playerContainer.setHTML(playerCode);
	},

	showPlayer : function(){
		if (this.visible) {
			return;
		}
		this.visible = true;

		CB.Transitions.video();
		this.fromPage = CB.Transitions.openPage;
	},

	hidePlayer : function(){
		if (!this.visible) {
			return;
		}
		this.playerContainer.empty();
		this.visible = false;
		
		CB.Transitions.selectPage(this.fromPage);
	},

	play : function(url,provider,clipId,title,ownerId){
		this.clipId = clipId;
		if (provider == "podcast"){
			this.setupPlayerQuicktime(url,provider);
		} else {
			this.setupPlayer(url,provider);
		}
		this.showPlayer();
		
		if (title){
			title = title.split(": ");
			this.providerAnchor.setText(title[0]);
			if (ownerId) this.providerAnchor.href = "/provider/" + ownerId +"/" + title[0];
			this.titleSpan.setText(title[1] || "");
		}
	},

	saveClip : function(){
		if (this.clipId >= 0) {
			CB.Clip.save(this.clipId);
		}
	},
	shareClip : function(){
		if (this.clipId >= 0) {
			CB.Clip.share(this.clipId);
		}
	}
}



/* ------------------------------------------------------------------------------------------------
 * Realtime index
 * ------------------------------------------------------------------------------------------------
 */

CB.RealTimeIndex = {
	searchOptions : {
		rows : 50,
		userVideo : CB.$.searchOptions.userVideo,
		safeSearch : CB.$.searchOptions.safeSearch,
		sortBy : CB.$.searchOptions.sortBy
	},
	paused : false,
	htmlLoaded : false,
	clipsBuffer : [],
	refreshOrder : [5,8,1,4,2,0,6,3,7],
	refreshIndex : -1,
	size : 9,
	
	init : function(){
		this.element = $E("#portletRealtimeIndex dl");
		this.container = $E("#portletRealtimeIndex ul");
		this.template = new Template(CB.$.templates.clipRealTime);
		this.api = new Component.ClipsProvider(CB.$.api.realtime);
		this.api.addEvent("onComplete",this.storeClips.bind(this));
		this.tickerContent = $("realtimeTickerBody");
		this.loadClips();
		this.Counter.init();
		this.element.addEvent("mouseenter",this.pause.bind(this));
		this.element.addEvent("mouseleave",this.resume.bind(this));
	},
	
	loadClips : function(){
		this.searchOptions.r = $random(0,9999999999);
		this.api.request(this.searchOptions);
	},

	pause : function(){
		$clear(this.delay);
		this.paused = true;
	},

	resume : function(){
		if (!this.paused) {
			return;
		}
		$clear(this.delay);
		this.paused = false;
		this.refreshClip();
	},
	
	refreshClip : function(){
		if (this.paused) {
			return;
		}

		this.refreshIndex++;
		if (this.refreshIndex>=this.size){
			this.refreshIndex = 0;
		}
		if (this.clipsBuffer.length==10){
			this.loadClips();
		}
		var clip = this.clipsBuffer.shift();
		if (clip){
			var node = this.nodes[this.refreshOrder[this.refreshIndex]];
			var newImage = new Asset.image(clip.image, {onload: function(node,clip){
				var link = node.getElement("a");
				var imageContainer = node.getElement("span");
				var oldImageSpan = imageContainer.getElement("span");
				newImageSpan = new Element("span").injectTop(imageContainer);
				newImage.injectTop(newImageSpan);
				new Fx.Style(newImageSpan,"opacity").set(0).start(1);
				new Fx.Style(oldImageSpan,"opacity",{onComplete:function(){
					this.remove();
				}.bind(oldImageSpan)}).start(0);
				link.href = clip.url;
				link.getElement("span").setText(clip.title);
				this.delay = this.refreshClip.delay(2000,this);
			}.bind(this,[node,clip])});
		}
	},
	
	storeClips : function(clips){
		this.clipsBuffer.extend(clips);
		if (!this.htmlLoaded){
			this.loadHTML(clips);
		}
	},
	
	loadHTML : function(clips){
		var html = "";
		for (var i=0;i<this.size;i++){
			var clip = this.clipsBuffer.shift();
			html += this.template.evaluate(clip);
		}
		this.container.innerHTML = html;
		CB.Controller.hijackEvents(this.container);
		this.nodes = this.container.getElements("li");
		this.htmlLoaded = true;
		this.refreshClip();
	},
	
	Counter : {
		init: function(){
			this.element = $E("#portletRealtimeIndex dt strong");
			new Ajax(CB.$.api.totalClips,{
				onComplete : function(responseText){
					this.amount = parseInt(responseText);
					var amount =  responseText.split("").reverse().join("").replace(/(\d{3})/g,"$1\,").replace(/\.$/,"").split("").reverse().join("");
					this.element.innerHTML = amount;
					new Ajax(CB.$.api.hourlyClips,{
						onComplete : function(responseText){
							this.count(parseInt(responseText.replace(/^\D/,"")));
						}.bind(this)
					}).request();
					
				}.bind(this)
			}).request();
		},
		
		count : function(hourlyAverage){
			if (hourlyAverage == 0){
				hourlyAverage = 1;
			}
			var interval = (3600/hourlyAverage)*1000;
			(function(){
				this.amount++;
				this.element.innerHTML = this.amount.toString().split("").reverse().join("").replace(/(\d{3})/g,"$1\,").replace(/\.$/,"").split("").reverse().join("");
			}).periodical(interval,this);
		}
	}
}
$extend(CB.RealTimeIndex,new Events);


/* ------------------------------------------------------------------------------------------------
 * Widget transitions
 * ------------------------------------------------------------------------------------------------
 */
CB.Transitions = {
	init : function(){
		this.hideChain = null;
		this.pageLoaded = true;

		this.pages = new Array("providers", "categories", "myClips", "recentViews", "savedSearches", "myProviders", "myCategories", "results");
		this.pagesFx = new Array();
		this.pages.each(function(page, i){
			this.pagesFx[i] = new Fx.Style($(page), "opacity",{});
		}.bind(this));
		this.pageSelector = $$("#searchBox h3 select")[0];
		this.pageTitle = $$("#searchBox h3 span")[0];

		this.pageSelector.addEvent('change', function(event){
			this.selectPage(this.pageSelector.selectedIndex);
		}.bindAsEventListener(this));

		this.playerButtonsFx = new Fx.Style($("videoFunctions"),"height",{});
		this.videoVisible = false;

		this.homepageOpen = $('providers').className == "open";

		this.saveMessage = $('messageClipSaved');
		this.saveEffect = this.saveMessage.effect('opacity', {duration: 250, transition: Fx.Transitions.linear});
		
		this.shareMessage = $('messageShare');
		this.shareEffect = this.shareMessage.effect('opacity', {duration: 250, transition: Fx.Transitions.linear});
		
		this.pageHeader = $E("#searchBox h3");
		this.pageHeaderFx = new Fx.Style(this.pageHeader,"opacity",{});
		
		this.searchBox = $("searchBox");
		this.searchFx = new Fx.Style(searchBox,"height",{});
		this.toggle = $("togglePanel");
		this.toggle.addEvent("click",function(event){
			if (event){
				var event = new Event(event);
				event.stop();
			}
			this.fold();
		}.bindAsEventListener(this));

		this.selectPage(0,1);
	},

	selectPage : function(pageNumber,doNotFoldOut) {
		if (!doNotFoldOut) {
			this.foldOut();
		}

		//if (this.openPage != pageNumber) {
	
			if (pageNumber >= this.pageSelector.getChildren().length) {
				var results = new Element("option");
				results.setText("Search Results");
				results.injectInside(this.pageSelector);
			}

			this.openPage = pageNumber;
			this.pageSelector.selectedIndex = pageNumber;
			this.pageTitle.setText(this.pageSelector.getChildren()[pageNumber].value);
	
			this.hideAll(function(){
				var fx = this.pagesFx[pageNumber];
				fx.stop();
				fx.set(0);
				$(this.pages[pageNumber]).className = "open";
				fx.start(1).chain(this.setPageLoaded.bind(this));
			}.bind(this));
		//}

		switch (pageNumber) {
		case 0: // Providers
			CB.Portlets.providers.init();
			break;
		case 1: // Categories
			CB.Portlets.categories.init();
			break;
		case 2: // My Clips
			CB.Portlets.myClips.refresh();
			break;
		case 3: // Recent views
			CB.Portlets.recentViews.refresh();
			break;
		case 4: // Saved searches
			CB.Portlets.savedSearches.refresh();
			break;
		case 5: // My Providers
			CB.Portlets.myProviders.refresh();
			break;
		case 6: // My Categories
			CB.Portlets.myCategories.refresh();
			break;
		case 7: // Search Results
			break;
		}
	},
	
	reopenCurrentPage : function(){
		this.selectPage(this.openPage,("closed" == this.toggle.className));
	},

	search : function(){
		this.selectPage(7);
	},
	genericHomepage : function(){
		this.selectPage(0);
	},
	personalHomepage : function(){
		this.selectPage(2);
	},
	video : function(){
		this.foldOut();
		this.hideAll(function(){
			this.playerButtonsFx.set(0);
			$("video").style.display = "block";
			this.playerButtonsFx.start(19);
			this.pageHeader.style.display = "none";
			this.videoVisible = true;
			this.setPageLoaded();
		}.bind(this));
	},

	setPageLoaded : function(){
		this.pageLoaded = true;
		if (this.hideChain) {
			var chain = this.hideChain;
			this.hideChain = null;
			this.hideAll(chain);
		}
	},

	preferences : function(){
		this.foldOut();
	},

	videoHide : function(){
		if (!this.videoVisible) {
			return;
		}
		this.videoVisible = false;

		this.playerButtonsFx.start(0).chain(function(){
			$("video").style.display = "none";
		}.bind(this));
		this.pageHeader.style.display = "block";
		CB.Player.stop();
		return this.playerButtonsFx;
	},

	hideAll : function(chain) {
		if (this.hideChain) {
			this.hideChain = chain;
			return;
		}

		this.hideChain = chain;

		if (!this.pageLoaded) {
			return;
		}

		var group=new Group();
		var effect;

		effect = this.videoHide();
		if (effect){
			group.addElement(effect);
		}

		this.pagesFx.each(function(fx, i){
			group.addElement(fx);
			fx.start(0).chain(function(){
				$(this.pages[i]).className = "closed";
			}.bind(this));
		}.bind(this));

		var theChain = function(){
			group.stop('onComplete');
			var c = this.hideChain;

			this.pageLoaded = false;

			this.hideChain = null;
			c();
		}.bind(this);
		group.addEvent('onComplete',theChain);
	},

	fold : function(){
		if ("closed" == this.toggle.className) {
			this.foldOut();
		} else {
			this.foldIn();
		}
	},
	foldOut : function(){
		if ("closed" == this.toggle.className) {
			this.toggle.className = "open";
			this.searchFx.start(350);
			if (window.widget) {
				window.resizeTo(332, 683);
			}
		}
	},
	foldIn : function(chain){
		if ("open" == this.toggle.className) {
			CB.Player.stop();
			this.toggle.className = "closed";
			this.searchFx.start(-350).chain(function(){
				if (window.widget) {
					window.resizeTo(332, 180);
				}
			});
		}
	},

	savedShow : function(){
		if (CB.Player.visible) {
			$('Player').style.height = "0px";
		}

		this.saveEffect.set(1);
		this.saveMessage.style.display = "block";
	},
	savedHide : function(){
		this.saveEffect.start(0).chain(function(){
			this.saveMessage.style.display = "none";
			$('Player').style.height = "";
		}.bind(this));
	},
	shareShow : function(){
		if (CB.Player.visible) {
			$('Player').style.height = "0px";
		}

		this.shareEffect.set(1);
		this.shareMessage.style.display = "block";
	},
	shareHide : function(){
		this.shareEffect.start(0).chain(function(){
			this.shareMessage.style.display = "none";
			$('Player').style.height = "";
		}.bind(this));
	}

}

/* ------------------------------------------------------------------------------------------------
 * Homepage panel
 * ------------------------------------------------------------------------------------------------
 */

CB.Homepage = {
	init : function(){
		this.link = $('logo');

		this.link.addEvent("click",function(event){
			if (event){
				var event = new Event(event);
				event.stop();
			}
			this.show();
		}.bindAsEventListener(this));
	},

	show : function(){
		if (CB.User.getId()) {
			CB.Transitions.personalHomepage();
		} else {
			CB.Transitions.genericHomepage();
		}
	}
};

/* ------------------------------------------------------------------------------------------------
 * Components
 * ------------------------------------------------------------------------------------------------
 */

// namespace for reusable components
var Component = {}

Component.Portlet = new Class({
	options : {
		width: 300,
		itemsOnSlide : 4,
		includesDir : CB.$.includesDir
	},
	
	initialize : function(element,options){
		this.setOptions(options);
		this.element = $(element);
		this.container = this.element.getElement("div.carousel");
		
		// pagination
		//this.header = this.element.getElement("h4");
		var prev = this.element.getElement(".buttonPrevious");
		var counter = this.element.getElement("em.counter");
		var next = this.element.getElement(".buttonNext");
		this.slider = new Fx.Style(this.container,"margin-left");
		this.pages = 1;
		this.current = 1;
		this.paginator = new Component.Paginator(counter, prev, next, this.previous.bind(this), this.next.bind(this));
		
		//this.load(element.id);
	},
	
	load : function(page){
		var url = this.options.includesDir + page + ".html";
		new Ajax(url, {update:this.container,method:"get",onComplete: function(){
			CB.Controller.hijackEvents(this.container);
			var size = this.container.getElements("ul").length;
			this.pages = Math.ceil(size / this.options.itemsOnSlide);
			this.container.setStyle("width",this.pages*this.options.width+"px");
			this.paginator.setPage(this.current, this.pages);
			this.fireEvent("onLoad",this.container);
		}.bind(this)}).request();
	},
	
	next : function(){
		var curr = this.current;
		if (curr < this.pages) {
			this.slider.stop();
			curr++;
			this.current = curr;
			this.slider.start(-(this.options.width * (curr - 1)));
			this.paginator.setPage(curr, this.pages);
		}
	},
	previous : function(){
		var curr = this.current;
		if (this.current > 1) {
			this.slider.stop();
			curr--;
			this.current = curr;
			this.slider.start(-(this.options.width * (curr - 1)));
			this.paginator.setPage(curr, this.pages);
		}
	}
});
Component.Portlet.implement(new Events,new Options);

Component.Loading = new Class({
	showLoading : function(){
		if (!this.loading){
			this.loading = new Element("p",{"class":"loading"}).setHTML("Loading, please wait…").injectInside(this.element);
			this.containerFx = new Fx.Style(this.container,"opacity",{wait:false});
		}
		this.loading.show();
		this.containerFx.start(0);
		return this;
	},
	
	hideLoading : function(){
		if (this.loading){
			this.loading.hide();
		}
		this.containerFx.start(1);
		return this;
	}
});

Component.Paginator = new Class({
	initialize : function(counter, previousButton, nextButton, previousMethod, nextMethod){
		this.counter = counter;
		this.previousButton = previousButton;
		this.nextButton = nextButton;
		this.previousMethod = previousMethod;
		this.nextMethod = nextMethod;

		this.previousButton.addEvent("click",function(event){
			if (event){
				var event = new Event(event);
				event.stop();
			}
			this.previousMethod();
		}.bindAsEventListener(this));
		this.nextButton.addEvent("click",function(event){
			if (event){
				var event = new Event(event);
				event.stop();
			}
			this.nextMethod();
		}.bindAsEventListener(this));
	},
	setPage : function(current, total){
		this.counter.setHTML(current+"/"+total);
			
		// sync next previous buttons
		this.previousButton[current==1 ? "addClass" : "removeClass"]("inactive");
		this.nextButton[current < total ? "removeClass" : "addClass"]("inactive");
	}
});


Component.SearchContainer = new Class({
	options : {
			offset: 0,
			searchKey: "72.51.43.55",
			output : "json"
	},
	
	initialize : function(container,options){
		this.setOptions(options);
		this.element = $(container);
		this.container = this.element.getElement("dl");
		if (!this.container){
			this.container = new Element("dl",{"class":"searchResults tile"}).injectInside(this.element);
		}
		
		this.api = new Component.ClipsProvider(CB.$.api.search);
		this.api.addEvent("onComplete",this.showResult.bind(this));
		this.api.addEvent("onFailure",this.showFailure.bind(this));
		this.clipDtTemplate = new Template(CB.$.templates.clipDt);
		this.clipDdTemplate = new Template(CB.$.templates.clipDd);
		this.clipPlayButtonTemplate = new Template(CB.$.templates.clipPlayButton);
	},
	
	start : function(options){
		this.fireEvent("beforeSearch");
		this.currentOptions = {};
		$extend(this.currentOptions,this.options);
		$extend(this.currentOptions,options||{});
		this.loadResult();
	},
	
	changeOption : function(option, value){
		this.options[option] = value;
		this.currentOptions[option] = value;
		this.loadResult();
	},
	
	next : function(){
		if (this.currentOptions.offset + this.options.limit <= this.numClips){
			this.currentOptions.offset += this.options.limit;
			this.loadResult();
		}
	},
	
	previous : function(){
		if (this.currentOptions.offset>=this.options.limit){
			this.currentOptions.offset -= this.options.limit;
			this.loadResult();
		}
	},
	
	filter : function(filterOptions,type){
		this.currentFilterType = type;
		$extend(this.currentOptions,filterOptions);
		this.currentOptions.offset = 0;
		this.loadResult();
	},
	
	openOffset : function(offset){
		this.currentOptions.offset = offset;
		this.loadResult();
	},
	
	loadResult : function(){
		this.api.request(this.currentOptions);
		this.showLoading();
	},
	
	showResult : function(clips,properties,metaData){
		this.container.empty();
		this.numClips = parseInt(properties.numFound);
		this.currentOptions.offset = parseInt(properties.start);
		this.currentOptions.safeSearch = properties.safeSearch;
		this.currentOptions.userVideo = properties.userVideo;
		this.currentOptions.sortBy = properties.sortOrder;
		console.log(this.currentOptions)
		this.metaData = metaData;
		
		// render the result
		clips.each(function(clip){
			if (!clip.title){clip.title = "";}
			if (!clip.description){clip.description = "";}
			if (clip.description.length>200){clip.description = clip.description.truncate(200);}
			var published = clip.published.match(/([0-9]{4})-([0-9]{2})-([0-9]{2}).*/);
			published[2] = published[2].replace(/^0/,"");
			published[3] = published[3].replace(/^0/,"");
			clip.published = published[3] + " " + CB.$.months[parseInt(published[2] - 1)] + " " + published[1];
			var player = CB.Player.getPlayer(clip.url,clip);
			clip.player = player ? player.provider : null;
			clip.asset = clip.url;
			if (clip.podcast && clip.podcast == true && clip.media_asset){
				clip.asset = clip.media_asset;
			}
			clip.playButton = player ? this.clipPlayButtonTemplate.evaluate(clip) : "";
			
			// create and insert nodes
			var dt = new Element("dt").injectInside(this.container);
			dt.setHTML(this.clipDtTemplate.evaluate(clip));
			var dd = new Element("dd").injectInside(this.container);
			dd.setHTML(this.clipDdTemplate.evaluate(clip));
			
			
			
		},this);
		
		this.fireEvent("resultLoaded",[this.container,properties,this.currentOptions,metaData]);
		this.hideLoading();
	},
	
	showFailure : function(){
		this.element.setHTML("Loading of page failed. Please try again.");
		this.hideLoading();
	}
});
Component.SearchContainer.implement(new Events,new Component.Loading, new Options);

Component.ClipsProvider = new Class({
	options : {
		threaded : false
	},
	
	initialize : function(api,options){
		this.setOptions(options);
		this.transport = new Ajax(api, {
			method: 'get',
			autoCancel: true,
			onComplete : this._returnClips.bind(this),
			onFailure : this.onFailure.bind(this)
		});
	},
	
	setApi : function(api){
		this.transport.url = api;
	},
	
	request : function(options){
		console.log("request");
		if (this.options.threaded){
			//this.transport.cancel();
		}
		this.transport.options.data = options;
		this.transport.request();
	},
	
	_returnClips : function(responseText,responseXML){
		if (!responseText){
			this.onFailure();
			return false;
		}
		this.result = Json.evaluate(responseText);
		this.clips = this.result.response.docs || [];
		this.properties = {
			numFound : this.result.response.numFound,
			start : this.result.response.start
		};
		this.metaData = this.result.metadata || {};
		$extend(this.properties,this.result.responseHeader.params || {});
		this.fireEvent("onComplete",[this.clips,this.properties,this.metaData]);
	},
	
	onFailure : function(){
		console.log("failure")
		this.fireEvent("onFailure");
	}
});
Component.ClipsProvider.implement(new Events, new Options);

Component.InputField = new Class({
	initialize : function(element){
		this.input = $(element);
		this.inputInstruction = $E("label[for='"+this.input.id+"'] em.instruction");
		if (this.inputInstruction){
			this.input.addEvents({
				"focus" : this._onFocus.bind(this),
				"blur" : this._onBlur.bind(this)
			});
			this.inputInstruction.addEvent("click",this._onFocus.bind(this))
		}
		this._onBlur();
	},
	
	_onFocus : function(){
		this.input.focus();
		this.input.addClass("focus");
		this.inputInstruction.style.display = "none";
	},
	
	_onBlur : function(){
		this.input.removeClass("focus");
		if (this.input.value==""){
			this.inputInstruction.style.display = "block";
		} else {
			this.inputInstruction.style.display = "none";
		}
	},
	
	getValue : function(){
		return this.input.value;
	},
	
	setValue : function(value){
		this.input.value = value;
	}
});
